/**
 * Copyright (C) 2010  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.bpmn2bpel.generators;

import javax.wsdl.PortType;
import javax.xml.namespace.QName;
import org.ow2.orchestra.jaxb.bpmn.Operation;

class OperationReference {
  private final String partnerLinkName;
  private final Operation operation;
  private final PortType portType;
  private final QName portTypeQName;

  OperationReference(final PortType portType, final String partnerLinkName, final Operation operation) {
    this.portType = portType;
    this.portTypeQName = portType.getQName();
    this.partnerLinkName = partnerLinkName;
    this.operation = operation;
  }

  OperationReference(final QName portTypeQName, final String partnerLinkName, final Operation operation) {
    this.portType = null;
    this.portTypeQName = portTypeQName;
    this.partnerLinkName = partnerLinkName;
    this.operation = operation;
  }

  String getPartnerLinkName() {
    return this.partnerLinkName;
  }

  Operation getOperation() {
    return this.operation;
  }

  QName getPortTypeQName() {
    return this.portTypeQName;
  }

  public PortType getPortType() {
    return portType;
  }
}
